unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  DBGrids, sqldb, Sqlite3DS, db, sqlite3conn;

type

  { TForm1 }

  TForm1 = class(TForm)
    ButtonFind: TButton;
    ButtonDel: TButton;
    ButtonAdd: TButton;
    DataSource: TDataSource;
    DBGrid: TDBGrid;
    EditID: TEdit;
    EditTel: TEdit;
    EditFIO: TEdit;
    SQLite3Dataset: TSqlite3Dataset;
    SQLite3Connection: TSQLite3Connection;
    SQLQuery: TSQLQuery;
    SQLTransaction: TSQLTransaction;
    procedure ButtonAddClick(Sender: TObject);
    procedure ButtonDelClick(Sender: TObject);
    procedure ButtonFindClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.ButtonAddClick(Sender: TObject);
begin
  SQLite3Dataset.Close;

  with SQLQuery do
  begin
    SQL.Clear;
    SQL.Add('INSERT INTO devlaz(fio, tel) VALUES(:FIO,:TEL)');
    ParamByName('FIO').Text:=EditFIO.Text;
    ParamByName('TEL').Text:=EditTEL.Text;
    ExecSQL;
    SQLTransaction.Commit;
    Close;
  end;

  SQLite3Dataset.Open;
end;

procedure TForm1.ButtonDelClick(Sender: TObject);
begin
  SQLite3Dataset.Close;

  with SQLQuery do
  begin
    SQL.Clear;
    SQL.Add('DELETE FROM devlaz where id=:ID');
    ParamByName('ID').Text:=EditID.Text;
    ExecSQL;
    SQLTransaction.Commit;
    Close;
  end;

  SQLite3Dataset.Open;
end;

procedure TForm1.ButtonFindClick(Sender: TObject);
begin
  with SQLQuery do
  begin
    SQL.Clear;
    SQL.Add('SELECT * FROM devlaz where id = :id');
    ParamByName('id').Text:=EditID.Text;
    Open;
  end;

  ShowMessage(SQLQuery.FieldByName('fio').AsString);
  SQLQuery.Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  {Параметры компонентов работы с базой
  Можно выставить в опциях у каждого компонента.}
  //*******************************
  SQLite3Dataset.FileName:='devlaz.db';
  SQLite3Dataset.TableName:='devlaz';
  DataSource.DataSet:=SQLite3Dataset;
  SQLite3Connection.DatabaseName:='devlaz.db';
  SQLite3Connection.Transaction:=SQLTransaction;
  SQLTransaction.DataBase:=SQLite3Connection;
  SQLQuery.DataBase:=SQLite3Connection;
  SQLQuery.Transaction:=SQLTransaction;
  //*******************************

  try
     SQLite3Dataset.Open;
     SQLite3Connection.Connected:=True;
  except
     On E:Exception do
        ShowMessage('Ошибка открытия базы: '+ E.Message);
  end;
end;


end.

